
#include <glib.h>

// Disable the 'const' function attribute of the get_type() functions.
// GCC would optimize them out because we don't use the return value.
#undef  G_GNUC_CONST
#define G_GNUC_CONST /* empty */

#include <libgnomevfsmm/wrap_init.h>
#include <glibmm/error.h>
#include <glibmm/object.h>

// #include the widget headers so that we can call the get_type() static methods:

#include "enums.h"
#include "file-info.h"
#include "uri.h"
#include "mime-monitor.h"
#include "mime-application.h"
#include "mime-action.h"
#include "transfer-progress.h"
#include "async-handle.h"
#include "drive.h"
#include "volume.h"
#include "volume-monitor.h"
#include "address.h"
#include "resolve-handle.h"

extern "C"
{

//Declarations of the *_get_type() functions:

GType gnome_vfs_drive_get_type(void);
GType gnome_vfs_mime_monitor_get_type(void);
GType gnome_vfs_volume_get_type(void);
GType gnome_vfs_volume_monitor_get_type(void);

//Declarations of the *_error_quark() functions:

} // extern "C"


//Declarations of the *_Class::wrap_new() methods, instead of including all the private headers:

namespace Gnome { namespace Vfs {  class Drive_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  } }
namespace Gnome { namespace Vfs {  class MimeMonitor_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  } }
namespace Gnome { namespace Vfs {  class Volume_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  } }
namespace Gnome { namespace Vfs {  class VolumeMonitor_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  } }

namespace Gnome { namespace Vfs { 

void wrap_init()
{
  // Register Error domains:

// Map gtypes to gtkmm wrapper-creation functions:
  Glib::wrap_register(gnome_vfs_drive_get_type(), &Gnome::Vfs::Drive_Class::wrap_new);
  Glib::wrap_register(gnome_vfs_mime_monitor_get_type(), &Gnome::Vfs::MimeMonitor_Class::wrap_new);
  Glib::wrap_register(gnome_vfs_volume_get_type(), &Gnome::Vfs::Volume_Class::wrap_new);
  Glib::wrap_register(gnome_vfs_volume_monitor_get_type(), &Gnome::Vfs::VolumeMonitor_Class::wrap_new);

  // Register the gtkmm gtypes:
  Gnome::Vfs::Drive::get_type();
  Gnome::Vfs::MimeMonitor::get_type();
  Gnome::Vfs::Volume::get_type();
  Gnome::Vfs::VolumeMonitor::get_type();

} // wrap_init()

} //Vfs
} //Gnome


